/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package show;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Vector;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import lab.Car;
import lab.CarPark;

/**
 *
 * @author Bruker
 */

public class CarParkServletFinal extends HttpServlet {

  /**
   * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
   * methods.
   *
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  protected void processRequest(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    response.setContentType("text/html;charset=UTF-8");
    try (PrintWriter out = response.getWriter()) {
      // get the session object
      // if not exists - create one
      HttpSession session = request.getSession();
      // get the carPark object from the session object
      CarPark carPark = (CarPark) session.getAttribute("carPark");
      // if no carPark object exists on the session object - create one
      if (carPark == null) {
        carPark = new CarPark();
        session.setAttribute("carPark", carPark);
      }
      // Test for any request parameters
      Enumeration enumr = request.getParameterNames();
      if (enumr.hasMoreElements()) {
        // Register a new car only if the regNo have a value
        if (!request.getParameter("regNo").equals("")) {
          Car car = new Car();
          car.setRegNo(request.getParameter("regNo"));
          car.setCartype(request.getParameter("cartype"));
          car.setModel(Integer.parseInt(request.getParameter("model")));
          car.setDayPrice(Double.parseDouble(request.getParameter("dayPrice")));
          carPark.addCar(car);  // add a car to the carPark object
        }
      }
      // get all the cars that are regitered
      Vector<Car> cars = carPark.getCars();
      // print out to the response a table header for all cars
      out.println("<html><body>");
      out.println(" <h2>Registered Cars</h2>");
      out.println("  <table border=\"1px\" >");
      out.println("   <tr>");
      out.println("    <td align=\"left\" style=\"width:120px\" >RegNo:</td>");
      out.println("    <td align=\"left\" style=\"width:120px\">Cartype:</td>");
      out.println("    <td align=\"left\" style=\"width:120px\">Model:</td>");
      out.println("    <td align=\"left\" style=\"width:120px\">DayPrice:</td>");
      out.println("   </tr>");
      // If any car regitered - get each car and print out to the response
      // a table row for each car
      if (!cars.isEmpty()) {
        for (int i = 0; i < cars.size(); i++) {
          Car car = (Car) cars.get(i);
          out.println("   <tr>");
          out.println("    <td align=\"left\">" + car.getRegNo() + "</td>");
          out.println("    <td align=\"left\">" + car.getCartype() + "</td>");
          out.println("    <td align=\"left\">" +
                  String.valueOf(car.getModel()) + "</td>");
          out.println("    <td align=\"left\">" +
                  String.valueOf(car.getDayPrice()) + "</td>");
          out.println("   </tr>");
        }
      }
      out.println("  </table>");
      out.println(" <p><a href=\"/ServletFinal01/RegCars.html\">Return" +
              "</a> car registration</p>");
      out.println("</body></html>");
    }
  }

  // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
  /**
   * Handles the HTTP <code>GET</code> method.
   *
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  @Override
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    processRequest(request, response);
  }

  /**
   * Handles the HTTP <code>POST</code> method.
   *
   * @param request servlet request
   * @param response servlet response
   * @throws ServletException if a servlet-specific error occurs
   * @throws IOException if an I/O error occurs
   */
  @Override
  protected void doPost(HttpServletRequest request, HttpServletResponse response)
          throws ServletException, IOException {
    processRequest(request, response);
  }

  /**
   * Returns a short description of the servlet.
   *
   * @return a String containing servlet description
   */
  @Override
  public String getServletInfo() {
    return "Short description";
  }// </editor-fold>

}
